make=make --no-print-directory -iBs

SHOTNOZ=`echo 'SELECT tc.shotno FROM shots AS tc WHERE tc.status = '0' ORDER BY tc.date LIMIT 1'|mysql -Nu tokamakg_tgro -p'fusion_572' GolemVirtualDischarges`
SHOTNOI=`echo 'SELECT tc.shotno FROM shots AS tc WHERE tc.status = '1' ORDER BY tc.date LIMIT 1'|mysql -Nu tokamakg_tgro -p'fusion_572' GolemVirtualDischarges`
VSHOTNO=`cat vshotno`
SLEEP_TIME=10


kernel:
	xterm -T "Remote session master" -hold -e "make all -iB"

test:
	echo $(SHOTNOZ)

all:
	sudo chgrp -R golem /srv/www/golem/roperation/tasks
	sudo chmod -R g+w /srv/www/golem/roperation/tasks
	while [ 1 ]; do \
	if [ `echo 'SELECT tc.status FROM shots AS tc WHERE tc.status = '1' ORDER BY tc.date'|mysql -Nu tokamakg_tgro -p'fusion_572' GolemRemoteDischarges|wc -l` != 0 ]; then \
	echo "PROBLEM! status in database -eq 1 - not allowed"; sleep 2s;\
	elif [ `echo 'SELECT tc.status FROM shots AS tc WHERE tc.status = '0' ORDER BY tc.date'|mysql -Nu tokamakg_tgro -p'fusion_572' GolemRemoteDischarges|wc -l` != 0 ]; then \
	echo "SHOT!";\
	make -iB discharge;\
	echo "Chance to stop it, sleeping";sleep $(SLEEP_TIME)s;\
	else \
		echo "sleeping";sleep 2s;\
	fi;\
	done 

allsafe:
	sudo chgrp -R golem /srv/www/golem/roperation/tasks
	sudo chmod -R g+w /srv/www/golem/roperation/tasks
	while [ 1 ]; do \
	if [ `echo 'SELECT tc.status FROM shots AS tc WHERE tc.status = '0' ORDER BY tc.date'|mysql -Nu tokamakg_tgro -p'fusion_572' GolemRemoteDischarges|wc -l` != 0 ]; then \
	echo "SHOT!";\
	make -iB discharge;\
	echo "Chance to stop it, sleeping";sleep $(SLEEP_TIME)s;\
	else \
		echo "sleeping";sleep 2s;\
	fi;\
	done 

allwork:
	while [ 1 ]; do 
	if [ `echo 'SELECT tc.status FROM shots AS tc WHERE tc.status = '0' ORDER BY tc.date'|mysql -Nu tokamakg_tgro -p'fusion_572' GolemRemoteDischarges|wc -l` != 0 ]; then 
	echo "SHOT!"
	make -iB discharge &
	sleep 2s
	while [ ! -f "/home/svoboda/GOLEM/operation/currentshot/basicdiagn/Plasma" ] ; do \
	$(make) -iB index;sleep 2s;done;\
	echo "Discharge within 10s .." >> index.html;\
	shotno=`cat /home/svoboda/GOLEM/operation/currentshot/ShotNo`;\
	echo 'UPDATE `GolemRemoteDischarges`.`shots` SET shotno = '$$shotno' WHERE status = '1' ORDER BY date LIMIT 1'|mysql -Nu tokamakg_tgro -p'fusion_572' GolemRemoteDischarges;\
	echo 'UPDATE `GolemRemoteDischarges`.`shots` SET status = '2' WHERE status = '1' ORDER BY date LIMIT 1'|mysql -Nu tokamakg_tgro -p'fusion_572' GolemVirtualDischarges
	make -iB postdischarge
	echo "Chance to stop it, sleeping";sleep $(SLEEP_TIME)s;\
	else \
		echo "sleeping";sleep 2s;\
	fi;\
	done;

discharge:
	Ub=`echo 'SELECT tc.ub FROM shots AS tc WHERE tc.status = '0' ORDER BY tc.date LIMIT 1'|mysql -Nu tokamakg_tgro -p'fusion_572' GolemRemoteDischarges`;\
	Ucd=`echo 'SELECT tc.ucd FROM shots AS tc WHERE tc.status = '0' ORDER BY tc.date LIMIT 1'|mysql -Nu tokamakg_tgro -p'fusion_572' GolemRemoteDischarges`;\
	Tcd=`echo 'SELECT tc.tcd FROM shots AS tc WHERE tc.status = '0' ORDER BY tc.date LIMIT 1'|mysql -Nu tokamakg_tgro -p'fusion_572' GolemRemoteDischarges`;\
	pres_WG=`echo 'SELECT tc.h2 FROM shots AS tc WHERE tc.status = '0' ORDER BY tc.date LIMIT 1'|mysql -Nu tokamakg_tgro -p'fusion_572' GolemRemoteDischarges`;\
	type_WG=`echo 'SELECT tc.gas FROM shots AS tc WHERE tc.status = '0' ORDER BY tc.date LIMIT 1'|mysql -Nu tokamakg_tgro -p'fusion_572' GolemRemoteDischarges`;\
	ion=`echo 'SELECT tc.ion FROM shots AS tc WHERE tc.status = '0' ORDER BY tc.date LIMIT 1'|mysql -Nu tokamakg_tgro -p'fusion_572' GolemRemoteDischarges`;\
	Comment=`echo 'SELECT tc.Comment FROM shots AS tc WHERE tc.status = '0' ORDER BY tc.date LIMIT 1'|mysql -Nu tokamakg_tgro -p'fusion_572' GolemRemoteDischarges`;\
	Identification=`echo 'SELECT tc.Identification FROM shots AS tc WHERE tc.status = '0' ORDER BY tc.date LIMIT 1'|mysql -Nu tokamakg_tgro -p'fusion_572' GolemRemoteDischarges`;\
	vstab_predefined=`echo 'SELECT tc.vstab_predefined FROM shots AS tc WHERE tc.status = '0' ORDER BY tc.date LIMIT 1'|mysql -Nu tokamakg_tgro -p'fusion_572' GolemRemoteDischarges`;\
	hstab_predefined=`echo 'SELECT tc.hstab_predefined FROM shots AS tc WHERE tc.status = '0' ORDER BY tc.date LIMIT 1'|mysql -Nu tokamakg_tgro -p'fusion_572' GolemRemoteDischarges`;\
	vstab_feedback=`echo 'SELECT tc.vstab_feedback FROM shots AS tc WHERE tc.status = '0' ORDER BY tc.date LIMIT 1'|mysql -Nu tokamakg_tgro -p'fusion_572' GolemRemoteDischarges`;\
	hstab_feedback=`echo 'SELECT tc.hstab_feedback FROM shots AS tc WHERE tc.status = '0' ORDER BY tc.date LIMIT 1'|mysql -Nu tokamakg_tgro -p'fusion_572' GolemRemoteDischarges`;\
	echo "Preparing for next shot" > golemstatus;\
	echo 'UPDATE `GolemRemoteDischarges`.`shots` SET status = '1' WHERE status = '0' ORDER BY date LIMIT 1'|mysql -Nu tokamakg_tgro -p'fusion_572' GolemRemoteDischarges;\
	echo "<html><META HTTP-EQUIV='Refresh' CONTENT='3'><body><h1>Preparing for discharge ... </h1>" > index.html;\
	sleep 6s;\
	if true ; then\
		ssh golem@golem.fjfi.cvut.cz "PATH=/home/golem/anaconda3/bin:$$PATH;cd /home/svoboda/Dirigent;./Dirigent.sh --discharge --UBt $$Ub --TBt 0 --Ucd $$Ucd --Tcd $$Tcd --preionization $$ion --gas $$type_WG --pressure $$pres_WG --comment \"$$Identification $$Comment\" " ;\
	elif [ $$h2 -eq "0" ]; then \
	make -iBs -C /home/svoboda/GOLEM/velin/ shotbase  Ub=$$Ub Ucd=$$Ucd Tcd=$$Tcd Ubd=00 Tbd=0000 Ust=0 Tst=000 pH2=0 H2filling=0 PreIon=$$ion X11=3 COMMENT="$$Identification - $$Comment" & \
	else \
	make -iBs -C /home/svoboda/GOLEM/velin/ shotbase  Ub=$$Ub Ucd=$$Ucd Tcd=$$Tcd Ubd=00 Tbd=0000 Ust=0 Tst=000 pH2=$$h2 H2filling=1 PreIon=$$ion X11=3 COMMENT="$$Identification - $$Comment" & \
	fi;\
	sleep 2s;\
	if false ; then while [ ! -f "/home/svoboda/GOLEM/velin/generate_dynamic_shots/currentshot/nabijeni/charged" ] ; do \
	$(make) -iB index;sleep 2s;done;\
	while [ ! -f "/home/svoboda/GOLEM/velin/generate_dynamic_shots/currentshot/trigger" ] ; do \
	echo "<html><META HTTP-EQUIV='Refresh' CONTENT='2'><body><h2>Capacitors charged ..</h2>" > index.html;sleep 1s;done;\
	echo "<html><META HTTP-EQUIV='Refresh' CONTENT='10'><body><h2>Discharge in 10 s ..</h2>" > index.html; sleep 10s;\
	while [ ! -f "/srv/www/svoboda/golem/operation/currentshot/dataready" ] ; do \
	echo "<html><META HTTP-EQUIV='Refresh' CONTENT='3'><body><h2>Processing data:</h2><ul>" > index.html; tail -n 10 actions.log | sed 's/^/<li>/g' >> index.html; echo "</ul></body></html>" >> index.html ;sleep 1s;done; fi ; \
	shotno=`curl golem.fjfi.cvut.cz/GMshm/shot_no`;\
	echo 'UPDATE `GolemRemoteDischarges`.`shots` SET shotno = '$$shotno' WHERE status = '1' ORDER BY date LIMIT 1'|mysql -Nu tokamakg_tgro -p'fusion_572' GolemRemoteDischarges;\
	rm -f actions.log
	make -iB postdischarge
	echo 'UPDATE `GolemRemoteDischarges`.`shots` SET status = '2' WHERE status = '1' ORDER BY date LIMIT 1'|mysql -Nu tokamakg_tgro -p'fusion_572' GolemVirtualDischarges

sendreport:
	read -p "Send email report for virtual shot: " vshotno;\
	shotno=`echo "SELECT shotno FROM shots  WHERE vshotno = $$vshotno ORDER BY date LIMIT 1"|mysql -Nu tokamakg_tgro -p'fusion_572' GolemRemoteDischarges`;\
	tempf=`mktemp`;\
	recepient=`echo "SELECT email FROM shots  WHERE vshotno = $$vshotno ORDER BY date LIMIT 1"|mysql -Nu tokamakg_tgro -p'fusion_572' GolemRemoteDischarges`;\
	echo "Sending discharge link to " $$recepient;\
	echo "To: " $$recepient >> $$tempf;\
	echo -e "From: svoboda@fjfi.cvut.cz\n\
	Subject: Discharge $$shotno execution completed at the GOLEM tokamak\n\
	Greetings,\n\n\
	Your discharge setup has been executed.\n\
	You can review the results at http://golem.fjfi.cvut.cz/shots/$$shotno \n\n\
	Kind regards,\n\
	GOLEM tokamak team" >> $$tempf;\
	sendmail -t < $$tempf;\
	rm -f $$tempf;\
	echo Done;\

newuser:
	read -p "Add new user for remote sessions (including task name): " username;\
	echo "sorry, not implemented yet"
#	mkdir /srv/www/svoboda/golem/roperation

postdischarge:
	if [ `cat /srv/www/svoboda/golem/operation/currentshot/basicdiagn/Plasma` -eq 1 ]; then \
	echo "<html><META HTTP-EQUIV='Refresh' CONTENT='3'><body><h1>!!PLASMA!! </h1><h2>congratulations ..</h2>" > index.html;\
	echo ":PLASMA!" > golemstatus;\
	sleep 5s;\
	else \
	echo "<html><META HTTP-EQUIV='Refresh' CONTENT='3'><body><h1>!NO PLASMA! </h1>" > index.html;\
	echo ":NO PLASMA" > golemstatus;\
	sleep 5s;\
	fi
	shotno=`cat /srv/www/svoboda/golem/operation/currentshot/ShotNo`;\
	cp /srv/www/svoboda/golem/velin/generate_dynamic_shots/shots/$$shotno/basicdiagn/graphpres.png graphpres_$$shotno.png;\
	echo "<html><META HTTP-EQUIV='Refresh' CONTENT='10'><body><h1>Diagnostics ($$shotno)</h1><img src=\"graphpres_$$shotno.png\"></img>" > index.html;\
	sleep 10s;\
	echo "<html><META HTTP-EQUIV='Refresh' CONTENT='3'><body><h1>Waiting for next shot</h1>" > index.html;\
	rm -f graphpres_$$shotno.png
	echo "Waiting for next shot ..." > golemstatus


shotbase:
	echo SHOT with $$Ub and $$pH2 and $$H2filling and $$COMMENT

index:
	echo -e "<html><META HTTP-EQUIV='Refresh' CONTENT='1'><body><h1>Capacitors charging ..</h1><pre>Time\tU<sub>B</sub>\tU<sub>BD</sub>\tU<sub>CD</sub>\tp<sub>chamber</sub>" > index.html;\
	tail -n 10 /home/svoboda/GOLEM/velin/generate_dynamic_shots/currentshot/nabijeni/Time_AD4ETHb | awk '{print $$1 "\t" $$2 "\t" $$3 "\t" $$4 "\t" $$6}' >> index.html;\


kill:
	ps -Af|grep SELECT|head -1|awk '{print $$2}'|xargs kill

cleandb:
	echo "UPDATE shots SET status='2' WHERE status = '0' OR status = '1'" | mysql -Nu tokamakg_tgro -p'fusion_572' GolemRemoteDischarges
